	.dbfile C:\iccv7arm\MI9214~1\MicroBoltAccurateDelays.c
	AREA	"C$$code", CODE, READONLY
	CODE32
	ALIGN 4
	.dbfile C:\iccv7arm\MI9214~1\MicroBoltAccurateDelays.c
	EXPORT _main
	.dbfunc e main _main fV
	AREA	"C$$code", CODE, READONLY
	CODE32
	ALIGN 4
_main:
	stmfd R13!,{R14}
	.dbline -1
	.dbline 37
; /*
; |------------------------------------------------------------------------------------------
; |------------------------------------------------------------------------------------------
; | File Name			  : MicroBoltAccurateDelays.c																					
; | Author			    : Micromint, Inc.						
; | Copyright       : Copyright  2005, Micromint, Inc.																	
; | Creation Date		: 12/30/05																							
; | Version			    : 1.00																																												
; | Spaces per tab	:	2																									
; | Description		  : Main C file																																									 
; | Revision			  :	Initial																																																						
; |------------------------------------------------------------------------------------------
; |------------------------------------------------------------------------------------------
; */
; 
; /*
; |----------------------------------------------------
; |     Includes
; |----------------------------------------------------
; */
; 
; #include <ARM/philips/lpc210x.h>
; #include <arm_macros.h>
; #include "MicroBoltAccurateDelays.h"
; 
; /*
; |------------------------------------------------------------------------------------------
; |     Function        :   main
; |     Inputs          :   None
; |     Outputs         :   None
; |     Purpose         :   Main function for system
; |     Author			    :   Micromint, Inc.
; |------------------------------------------------------------------------------------------
; */
; 
; void main(void)
;   {
	.dbline 39
; 
;   __DISABLE_INTERRUPT();                        // Disable all interrupts
	mrs R12,cpsr
	orr R12,R12,#0x80
	msr cpsr_c,R12
	
	.dbline 46
; 
; /*
; |-------------------------
; | Config MAM 
; |-------------------------
; */
;   MAM_CR = 0x00;                                // Turn MAM off (default)
	mov R4,#0
	ldr R5,LIT_main+0
	str R4,[R5,#0]
	.dbline 47
;   MAM_TIM = 0x04;                               // Set flash timing to 4 clock cycles
	mov R4,#4
	ldr R5,LIT_main+4
	str R4,[R5,#0]
	.dbline 49
; 
;   MAM_CR = 0x02;                                // Fully enable the Memory Accleration Module
	mov R4,#2
	ldr R5,LIT_main+0
	str R4,[R5,#0]
	.dbline 56
; 
; /*
; |-------------------------
; | Config PLL and CCLK 
; |-------------------------
; */
;   SCB_PLLCFG |= 0x23;				 	   		            // Set to 59 MHz (0x03 is multiply value of 4)
	ldr R4,LIT_main+8
	ldr R5,[R4,#0]
	orr R5,R5,#35
	str R5,[R4,#0]
	.dbline 57
;   SCB_PLLCON |= 0x01;                           // Enable the PLL 
	ldr R4,LIT_main+12
	ldr R5,[R4,#0]
	orr R5,R5,#1
	str R5,[R4,#0]
	.dbline 58
;   SCB_PLLFEED = 0xAA;					   	  	          // Shadow register copy to enable changes
	mov R4,#170
	ldr R5,LIT_main+16
	str R4,[R5,#0]
	.dbline 59
;   SCB_PLLFEED = 0x55;                           // in PLLCON and PLLCFG
	mov R4,#85
	ldr R5,LIT_main+16
	str R4,[R5,#0]
	.dbline 66
; 
; /*
; |-------------------------
; | Config PCLK 
; |-------------------------
; */
;   SCB_VPBDIV = 0;                               // Peripheral clock is 1/4th Processor clock which equals 14.7456 MHz
	mov R4,#0
	ldr R5,LIT_main+20
	str R4,[R5,#0]
	.dbline 73
; 
; /*
; |-------------------------
; | Configure VIC 
; |-------------------------
; */
;   VICVectAddr0 = (unsigned)pll_isr;             // Assign the PLL lock ISR vector address
	ldr R4,LIT_main+24
	ldr R5,LIT_main+28
	str R4,[R5,#0]
	.dbline 74
;   VICVectCntl0 = INTERRUPT_CHANNEL_FOR_PLL;     // Assign the VIC address to the actual interrupt
	mov R4,#44
	ldr R5,LIT_main+32
	str R4,[R5,#0]
	.dbline 75
;   VICIntEnable = INTERRUPT_ENABLE_FOR_PLL;      // Enable the interrupt  
	mov R4,#4096
	ldr R5,LIT_main+36
	str R4,[R5,#0]
	.dbline 82
; 
; /*
; |-------------------------
; | Config GPIO 
; |-------------------------
; */
;   PCB_PINSEL0=0x00000000;                         
	mov R4,#0
	ldr R5,LIT_main+40
	str R4,[R5,#0]
	.dbline 83
;   PCB_PINSEL1=0x55400000;                       // Secondary JTAG pins 
	ldr R4,LIT_main+44
	ldr R5,LIT_main+48
	str R4,[R5,#0]
	.dbline 85
; 
;   GPIO_IODIR |= MICROBOLT_LED;                  // Setup MicroBolt LED as output
	ldr R4,LIT_main+52
	ldr R5,[R4,#0]
	orr R5,R5,#4194304
	str R5,[R4,#0]
	.dbline 86
;   GPIO_IODIR |= P0_9;                           // Setup P0_9 as output
	ldr R4,LIT_main+52
	ldr R5,[R4,#0]
	orr R5,R5,#512
	str R5,[R4,#0]
	.dbline 88
; 
;   GPIO_IOSET = MICROBOLT_LED;                   // Turn on MicroBolt LED
	mov R4,#4194304
	ldr R5,LIT_main+56
	str R4,[R5,#0]
	.dbline 90
; 
;   GPIO_IOCLR=0xffffffff;                        // Clear all pins to start with
	mvn R4,#0
	ldr R5,LIT_main+60
	str R4,[R5,#0]
	b L3
L2:
	.dbline 98
	.dbline 99
	mov R4,#4194304
	ldr R5,LIT_main+56
	str R4,[R5,#0]
	.dbline 101
	mov R4,#512
	ldr R5,LIT_main+56
	str R4,[R5,#0]
	.dbline 102
	bl _Delay10uS
	.dbline 103
	mov R4,#512
	ldr R5,LIT_main+60
	str R4,[R5,#0]
	.dbline 104
	bl _Delay10uS
	.dbline 106
	mov R4,#512
	ldr R5,LIT_main+56
	str R4,[R5,#0]
	.dbline 107
	bl _Delay100uS
	.dbline 108
	mov R4,#512
	ldr R5,LIT_main+60
	str R4,[R5,#0]
	.dbline 109
	bl _Delay100uS
	.dbline 111
	mov R4,#512
	ldr R5,LIT_main+56
	str R4,[R5,#0]
	.dbline 112
	bl _Delay1mS
	.dbline 113
	mov R4,#512
	ldr R5,LIT_main+60
	str R4,[R5,#0]
	.dbline 114
	bl _Delay1mS
	.dbline 116
	mov R4,#512
	ldr R5,LIT_main+56
	str R4,[R5,#0]
	.dbline 117
	bl _Delay10mS
	.dbline 118
	mov R4,#512
	ldr R5,LIT_main+60
	str R4,[R5,#0]
	.dbline 119
	bl _Delay10mS
	.dbline 121
	mov R4,#512
	ldr R5,LIT_main+56
	str R4,[R5,#0]
	.dbline 122
	bl _Delay100mS
	.dbline 123
	mov R4,#512
	ldr R5,LIT_main+60
	str R4,[R5,#0]
	.dbline 124
	bl _Delay100mS
	.dbline 126
	mov R4,#4194304
	ldr R5,LIT_main+60
	str R4,[R5,#0]
	.dbline 128
	mov R4,#512
	ldr R5,LIT_main+56
	str R4,[R5,#0]
	.dbline 129
	bl _Delay1Sec
	.dbline 130
	mov R4,#512
	ldr R5,LIT_main+60
	str R4,[R5,#0]
	.dbline 131
	bl _Delay1Sec
	.dbline 132
L3:
	.dbline 97
	b L2
X0:
	.dbline -2
L1:
	ldmfd R13!,{R15}
	.dbline 0 ; func end
	.dbfile C:\iccv7arm\MI9214~1\MicroBoltAccurateDelays.c
LIT_main:
	DCD -534790144
	DCD -534790140
	DCD -534790012
	DCD -534790016
	DCD -534790004
	DCD -534789888
	DCD _pll_isr
	DCD -3840
	DCD -3584
	DCD -4080
	DCD -536690688
	DCD 1430257664
	DCD -536690684
	DCD -536707064
	DCD -536707068
	DCD -536707060
	.dbend
	EXPORT _Delay10uS
	.dbfunc e Delay10uS _Delay10uS fV
	AREA	"C$$code", CODE, READONLY
	CODE32
	ALIGN 4
;          Delay -> R11,-4
_Delay10uS:
	mov R12,R13
	stmfd R13!,{R11,R12,R14}
	mov R11,R13
	sub R13,R13,#0x4
	.dbline -1
	.dbline 151
; 
; /*
; |----------------------------------------------------
; |     Start of application
; |----------------------------------------------------
; */
;   while(1)                                      // Do this forever
;     {
;     GPIO_IOSET = MICROBOLT_LED;                 // Turn on MicroBolt LED
; 
;     GPIO_IOSET = P0_9;                          // Measure delay via P0_9 On time (LPC2106 pin toggle takes about 1.4 uS)
;     Delay10uS();                                // 10 uS Delay
;     GPIO_IOCLR = P0_9;
;     Delay10uS();
; 
;     GPIO_IOSET = P0_9;                          
;     Delay100uS();                               // 100 uS Delay
;     GPIO_IOCLR = P0_9;
;     Delay100uS();
; 
;     GPIO_IOSET = P0_9;                          
;     Delay1mS();                                 // 1 mS Delay
;     GPIO_IOCLR = P0_9;
;     Delay1mS();
; 
;     GPIO_IOSET = P0_9;                          
;     Delay10mS();                                // 10 mS Delay
;     GPIO_IOCLR = P0_9;    
;     Delay10mS();
; 
;     GPIO_IOSET = P0_9;                          
;     Delay100mS();                               // 100 mS Delay
;     GPIO_IOCLR = P0_9;
;     Delay100mS();
; 
;     GPIO_IOCLR = MICROBOLT_LED;                 // Turn Off MicroBolt LED
; 
;     GPIO_IOSET = P0_9;                          
;     Delay1Sec();                                // 1 Second Delay
;     GPIO_IOCLR = P0_9;
;     Delay1Sec();
;     }
;   }
; 
; /*
; |----------------------------------------------------
; |     Functions
; |----------------------------------------------------
; */ 
; 
; /*
; |------------------------------------------------------------------------------------------
; |     Function        :   Delay10uS
; |     Inputs          :   None
; |     Outputs         :   None
; |     Purpose         :   Delay for 10 uS when PLLCFG is set to 0x23 (58.98 MHz) 
; |     Author          :   Micromint, Inc.
; |------------------------------------------------------------------------------------------
; */
; void Delay10uS(void)   
;   {
	.dbline 154
	mov R0,#0
	str R0,[R11,#-4]
	b L9
L6:
	.dbline 154
L7:
	.dbline 154
	ldr R0,[R11,#-4]
	add R0,R0,#1
	str R0,[R11,#-4]
L9:
	.dbline 154
; 	volatile unsigned int Delay;
; 
;   for (Delay = 0; Delay < 7; Delay++);          // Delay for 10 uS including function call
	ldr R0,[R11,#-4]
	cmp R0,#7
	blo L6
	.dbline -2
L5:
	ldmfd R11,{R11,SP,PC}
	.dbline 0 ; func end
	.dbfile C:\iccv7arm\MI9214~1\MicroBoltAccurateDelays.c
	.dbsym l Delay -4 i
	.dbend
	EXPORT _Delay100uS
	.dbfunc e Delay100uS _Delay100uS fV
	AREA	"C$$code", CODE, READONLY
	CODE32
	ALIGN 4
;          Delay -> R11,-4
_Delay100uS:
	mov R12,R13
	stmfd R13!,{R11,R12,R14}
	mov R11,R13
	sub R13,R13,#0x4
	.dbline -1
	.dbline 167
;   }
; 
; /*
; |------------------------------------------------------------------------------------------
; |     Function        :   Delay100uS
; |     Inputs          :   None
; |     Outputs         :   None
; |     Purpose         :   Delay for 100 uS when PLLCFG is set to 0x23 (58.98 MHz) 
; |     Author          :   Micromint, Inc.
; |------------------------------------------------------------------------------------------
; */
; void Delay100uS(void)   
;   {
	.dbline 170
	mov R0,#0
	str R0,[R11,#-4]
	b L14
L11:
	.dbline 170
L12:
	.dbline 170
	ldr R0,[R11,#-4]
	add R0,R0,#1
	str R0,[R11,#-4]
L14:
	.dbline 170
; 	volatile unsigned int Delay;
; 
;   for (Delay = 0; Delay < 109; Delay++);         // Delay for 100 uS including function call     
	ldr R0,[R11,#-4]
	cmp R0,#109
	blo L11
	.dbline -2
L10:
	ldmfd R11,{R11,SP,PC}
	.dbline 0 ; func end
	.dbfile C:\iccv7arm\MI9214~1\MicroBoltAccurateDelays.c
	.dbsym l Delay -4 i
	.dbend
	EXPORT _Delay1mS
	.dbfunc e Delay1mS _Delay1mS fV
	AREA	"C$$code", CODE, READONLY
	CODE32
	ALIGN 4
;          Delay -> R11,-4
_Delay1mS:
	mov R12,R13
	stmfd R13!,{R11,R12,R14}
	mov R11,R13
	sub R13,R13,#0x4
	.dbline -1
	.dbline 183
;   }
; 
; /*
; |------------------------------------------------------------------------------------------
; |     Function        :   Delay1mS
; |     Inputs          :   None
; |     Outputs         :   None
; |     Purpose         :   Delay for 1 mS when PLLCFG is set to 0x23 (58.98 MHz) 
; |     Author          :   Micromint, Inc.
; |------------------------------------------------------------------------------------------
; */
; void Delay1mS(void)   
;   {
	.dbline 186
	mov R0,#0
	str R0,[R11,#-4]
	b L19
L16:
	.dbline 186
L17:
	.dbline 186
	ldr R0,[R11,#-4]
	add R0,R0,#1
	str R0,[R11,#-4]
L19:
	.dbline 186
; 	volatile unsigned int Delay;
; 
;   for (Delay = 0; Delay < 1000; Delay++);       // Delay for 1 mS including function call
	ldr R0,[R11,#-4]
	cmp R0,#1000
	blo L16
	.dbline 187
	mov R0,#0
	str R0,[R11,#-4]
	b L23
L20:
	.dbline 187
L21:
	.dbline 187
	ldr R0,[R11,#-4]
	add R0,R0,#1
	str R0,[R11,#-4]
L23:
	.dbline 187
;   for (Delay = 0; Delay < 100; Delay++);       
	ldr R0,[R11,#-4]
	cmp R0,#100
	blo L20
	.dbline 188
	mov R0,#0
	str R0,[R11,#-4]
	b L27
L24:
	.dbline 188
L25:
	.dbline 188
	ldr R0,[R11,#-4]
	add R0,R0,#1
	str R0,[R11,#-4]
L27:
	.dbline 188
;   for (Delay = 0; Delay < 30; Delay++); 
	ldr R0,[R11,#-4]
	cmp R0,#30
	blo L24
	.dbline -2
L15:
	ldmfd R11,{R11,SP,PC}
	.dbline 0 ; func end
	.dbfile C:\iccv7arm\MI9214~1\MicroBoltAccurateDelays.c
	.dbsym l Delay -4 i
	.dbend
	EXPORT _Delay10mS
	.dbfunc e Delay10mS _Delay10mS fV
	AREA	"C$$code", CODE, READONLY
	CODE32
	ALIGN 4
;          Delay -> R11,-4
_Delay10mS:
	mov R12,R13
	stmfd R13!,{R11,R12,R14}
	mov R11,R13
	sub R13,R13,#0x4
	.dbline -1
	.dbline 201
;   }
; 
; /*
; |------------------------------------------------------------------------------------------
; |     Function        :   Delay10mS
; |     Inputs          :   None
; |     Outputs         :   None
; |     Purpose         :   Delay for 10 mS when PLLCFG is set to 0x23 (58.98 MHz) 
; |     Author          :   Micromint, Inc.
; |------------------------------------------------------------------------------------------
; */
; void Delay10mS(void)   
;   {
	.dbline 204
	mov R0,#0
	str R0,[R11,#-4]
	b L32
L29:
	.dbline 204
L30:
	.dbline 204
	ldr R0,[R11,#-4]
	add R0,R0,#1
	str R0,[R11,#-4]
L32:
	.dbline 204
; 	volatile unsigned int Delay;
; 
;   for (Delay = 0; Delay < 9200; Delay++);       // Delay for 10 mS including function call
	ldr R0,LIT_Delay10mS+0
	ldr R1,[R11,#-4]
	cmp R1,R0
	blo L29
	.dbline -2
L28:
	ldmfd R11,{R11,SP,PC}
	.dbline 0 ; func end
	.dbfile C:\iccv7arm\MI9214~1\MicroBoltAccurateDelays.c
LIT_Delay10mS:
	DCD 9200
	.dbsym l Delay -4 i
	.dbend
	EXPORT _Delay100mS
	.dbfunc e Delay100mS _Delay100mS fV
	AREA	"C$$code", CODE, READONLY
	CODE32
	ALIGN 4
;          Delay -> R11,-4
_Delay100mS:
	mov R12,R13
	stmfd R13!,{R11,R12,R14}
	mov R11,R13
	sub R13,R13,#0x4
	.dbline -1
	.dbline 217
;   }
; 
; /*
; |------------------------------------------------------------------------------------------
; |     Function        :   Delay100mS
; |     Inputs          :   None
; |     Outputs         :   None
; |     Purpose         :   Delay for 100 mS when PLLCFG is set to 0x23 (58.98 MHz) 
; |     Author          :   Micromint, Inc.
; |------------------------------------------------------------------------------------------
; */
; void Delay100mS(void)   
;   {
	.dbline 220
	mov R0,#0
	str R0,[R11,#-4]
	b L37
L34:
	.dbline 220
L35:
	.dbline 220
	ldr R0,[R11,#-4]
	add R0,R0,#1
	str R0,[R11,#-4]
L37:
	.dbline 220
; 	volatile unsigned int Delay;
; 
;   for (Delay = 0; Delay < 92000; Delay++);      // Delay for 100 mS including function call
	ldr R0,LIT_Delay100mS+0
	ldr R1,[R11,#-4]
	cmp R1,R0
	blo L34
	.dbline -2
L33:
	ldmfd R11,{R11,SP,PC}
	.dbline 0 ; func end
	.dbfile C:\iccv7arm\MI9214~1\MicroBoltAccurateDelays.c
LIT_Delay100mS:
	DCD 92000
	.dbsym l Delay -4 i
	.dbend
	EXPORT _Delay1Sec
	.dbfunc e Delay1Sec _Delay1Sec fV
	AREA	"C$$code", CODE, READONLY
	CODE32
	ALIGN 4
;          Delay -> R11,-4
_Delay1Sec:
	mov R12,R13
	stmfd R13!,{R11,R12,R14}
	mov R11,R13
	sub R13,R13,#0x4
	.dbline -1
	.dbline 233
;   }
; 
; /*
; |------------------------------------------------------------------------------------------
; |     Function        :   Delay1Sec
; |     Inputs          :   None
; |     Outputs         :   None
; |     Purpose         :   Delay for 1 Second when PLLCFG is set to 0x23 (58.98 MHz) 
; |     Author          :   Micromint, Inc.
; |------------------------------------------------------------------------------------------
; */
; void Delay1Sec(void)   
;   {
	.dbline 236
	mov R0,#0
	str R0,[R11,#-4]
	b L42
L39:
	.dbline 236
L40:
	.dbline 236
	ldr R0,[R11,#-4]
	add R0,R0,#1
	str R0,[R11,#-4]
L42:
	.dbline 236
; 	volatile unsigned int Delay;
; 
;   for (Delay = 0; Delay < 920000; Delay++);     // Delay for 1 Second including function call
	ldr R0,LIT_Delay1Sec+0
	ldr R1,[R11,#-4]
	cmp R1,R0
	blo L39
	.dbline -2
L38:
	ldmfd R11,{R11,SP,PC}
	.dbline 0 ; func end
	.dbfile C:\iccv7arm\MI9214~1\MicroBoltAccurateDelays.c
LIT_Delay1Sec:
	DCD 920000
	.dbsym l Delay -4 i
	.dbend
	EXPORT _pll_isr
	.dbfunc e pll_isr _pll_isr fV
	AREA	"C$$code", CODE, READONLY
	CODE32
	ALIGN 4
_pll_isr:
	sub R14,R14,#4
	stmfd R13!,{R0,R1,R11,R12,R14}
	mov R11,R13
	.dbline -1
	.dbline 251
;   }
; 
; /*
; |------------------------------------------------------------------------------------------
; |     Function        :   pll_isr
; |     Inputs          :   None
; |     Outputs         :   None
; |     Purpose         :   Once PLL has locked, connect it and use for system clock
; |     Author          :   Micromint, Inc.
; |------------------------------------------------------------------------------------------
; */
; #pragma interrupt_handler pll_isr
; 
; void pll_isr(void)
;   {
	.dbline 252
;   SCB_PLLCON |= 0x02;                           // Connect the PLL 
	ldr R0,LIT_pll_isr+0
	ldr R1,[R0,#0]
	orr R1,R1,#2
	str R1,[R0,#0]
	.dbline 253
;   SCB_PLLFEED = 0xAA;					   	  	          // Shadow register copy to enable changes
	mov R0,#170
	ldr R1,LIT_pll_isr+4
	str R0,[R1,#0]
	.dbline 254
;   SCB_PLLFEED = 0x55;                           // in PLLCON and PLLCFG
	mov R0,#85
	ldr R1,LIT_pll_isr+4
	str R0,[R1,#0]
	.dbline 255
;   VICIntEnClear = PLL_CLR;                      // Clear the PLL interrupt
	mov R0,#4096
	ldr R1,LIT_pll_isr+8
	str R0,[R1,#0]
	.dbline 256
;   VICVectAddr = VIC_ACK;                        // Acknowledge Interrupt
	mov R0,#0
	ldr R1,LIT_pll_isr+12
	str R0,[R1,#0]
	.dbline -2
L43:
	ldmfd R13!,{R0,R1,R11,R12,PC}^
	.dbline 0 ; func end
	.dbfile C:\iccv7arm\MI9214~1\MicroBoltAccurateDelays.c
LIT_pll_isr:
	DCD -534790016
	DCD -534790004
	DCD -4076
	DCD -4048
	.dbend
	END
